/*Copyright 2019 Chris Basinger

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.*/
package com.candroid.bootlaces

import android.content.Context
import org.koin.android.ext.koin.androidContext
import org.koin.dsl.module
/*
            (   (                ) (             (     (
            )\ ))\ )    *   ) ( /( )\ )     (    )\ )  )\ )
 (   (   ( (()/(()/(  ` )  /( )\()|()/((    )\  (()/( (()/(
 )\  )\  )\ /(_))(_))  ( )(_)|(_)\ /(_))\((((_)( /(_)) /(_))
((_)((_)((_|_))(_))   (_(_()) _((_|_))((_))\ _ )(_))_ (_))
| __\ \ / /|_ _| |    |_   _|| || | _ \ __(_)_\(_)   \/ __|
| _| \ V /  | || |__    | |  | __ |   / _| / _ \ | |) \__ \
|___| \_/  |___|____|   |_|  |_||_|_|_\___/_/ \_\|___/|___/
....................../´¯/)
....................,/¯../
.................../..../
............./´¯/'...'/´¯¯`·¸
........../'/.../..../......./¨¯\
........('(...´...´.... ¯~/'...')
.........\.................'...../
..........''...\.......... _.·´
............\..............(
..............\.............\...
*/
val libraryModule = module {
    single { BootLacesRepositoryImpl(androidContext()) }
    single { BootLacesServiceImpl(get(), androidContext()) }
}

class AppContainer(val ctx: Context){
    val service by lazy(LazyThreadSafetyMode.SYNCHRONIZED) { BootLacesServiceImpl(BootLacesRepositoryImpl(ctx),ctx) }
    //val service by inject<BootLacesServiceImpl>(clazz = BootLacesServiceImpl::class.java)
    companion object{
        private var INSTANCE: AppContainer? = null
        fun getInstance(ctx: Context): AppContainer{
            if(INSTANCE == null)
                INSTANCE = AppContainer(ctx)
            return INSTANCE!!
        }
    }
}